#!*****************************************************************************
#!*****************************************************************************
#TEMPLATE(TvS_SE,'Limit Procedure to Single Event Templates'),Family('ABC')
#!*****************************************************************************
#! Author : Theo von Solms 
#! Revised: 7 November 2003
#!*****************************************************************************
#HELP('Tvstemp.hlp')
#!==============================================================================================
#!==============================================================================================
#!---------------------------------------------------------------
#EXTENSION(TvS_SE_Glob_Loc,'TvS Single Event Global Extension - LOCAL'),APPLICATION,HLP('TvS_SE')
#!---------------------------------------------------------------
#!
#!
#SHEET
#TAB('TvS Template - Limit Procedure to Single Event')
#IMAGE('io2.ico'),AT(10,20)
#DISPLAY ('Innovative Options cc'),AT(40,20)
#DISPLAY ('Cape Town, South Africa'),AT(40,30)
#DISPLAY ('Tel: +27 21 5526013   Fax: +27 21 5525582')
#DISPLAY ('Email: innopt@iafrica.com')
#DISPLAY (' ')
#DISPLAY ('This template is part of a set used to disable and')
#DISPLAY ('enable Menu options and Controls to ensure that only')
#DISPLAY ('a single instance of a procedure can be opened at a time')
#DISPLAY (' ')
#DISPLAY ('The set consists of - TvS_SE_Glob  for Global Extension')
#DISPLAY ('                               - TvS_SE-Main  add to the Main App')
#DISPLAY ('                               - TvS_SE_Proc  add to the Procedure')
#DISPLAY (' ')
#DISPLAY (' Adds Global variables to a SINGLE Application OR to')
#DISPLAY (' to the Main DATA App in a Multi DLL application - use')
#DISPLAY (' along with TvS_SE_Glob_Ext for all individual DLLs in a')
#DISPLAY (' Multi DLL application')
#DISPLAY (' ')
#Button('Load Procedure Names'),Multi(%NoProcToAdd,%ProcToAdd),AT(40,205)
#BOXED('Procedure Definition'),AT(,12)
    #PROMPT('Procedure Name:',PROCEDURE),%ProcToAdd,UNIQUE
#ENDBOXED
#Endbutton
#DISPLAY ('  ')
#!
#ENDTAB
#ENDSHEET
#AT(%GlobalData)
#DECLARE(%Count,LONG)
#DECLARE(%Event1)
#DECLARE(%Event2)
#SET(%Count,401)
#FOR(%NoProcToAdd)
   #SET(%Event1,'Event:DISABLE' & %ProcToAdd & '     EQUATE(' & %Count & 'h)')
   #SET(%Count,%Count + 1)
   #SET(%Event2,'Event:ENABLE' & %ProcToAdd & '     EQUATE(' & %Count & 'h)')
   #SET(%Count,%Count + 1)
%Event1
%Event2
#ENDFOR
#ENDAT
#!
#GLOBALDATA
GLO:ThreadNo      LONG
GLO:ThreadCount   LONG
#ENDGLOBALDATA
#!
#!==============================================================================================
#!---------------------------------------------------------------
#EXTENSION(TvS_SE_Glob_Ext,'TvS Single Event Global Extension - EXTERNAL'),APPLICATION,HLP('TvS_SE')
#!---------------------------------------------------------------
#!
#!
#SHEET
#TAB('TvS Template - Limit Procedure to Single Event')
#IMAGE('io2.ico'),AT(10,20)
#DISPLAY ('Innovative Options cc'),AT(40,20)
#DISPLAY ('Cape Town, South Africa'),AT(40,30)
#DISPLAY ('Tel: +27 21 5526013   Fax: +27 21 5525582')
#DISPLAY ('Email: innopt@iafrica.com')
#DISPLAY (' ')
#DISPLAY ('This template is part of a set used to disable and')
#DISPLAY ('enable Menu options and Controls to ensure that only')
#DISPLAY ('a single instance of a procedure can be opened at a time')
#DISPLAY (' ')
#DISPLAY ('The set consists of - TvS_SE_Glob  for Global Extension')
#DISPLAY ('                               - TvS_SE-Main  add to the Main App')
#DISPLAY ('                               - TvS_SE_Proc  add to the Procedure')
#DISPLAY (' ')
#DISPLAY (' Adds Global variables to a DLL Application in a Multi')
#DISPLAY (' DLL application - use along with TvS_SE_Glob_Loc in ')
#DISPLAY (' the DATA DLL')
#DISPLAY (' ')
#DISPLAY ('IMPORTANT: ')
#DISPLAY ('  Each Procedure requires TWO unique Equate numbers')
#DISPLAY ('  You will be required to enter the starting number')
#DISPLAY ('  for each procedure - Start at number 401, 403, etc.')
#DISPLAY (' ')
#Button('Load Procedure Details'),Multi(%Buttons,%ProcToAdd & ' ' & %Start)
    #BOXED('Procedure Definition'),AT(,4)
        #PROMPT('Procedure Name:',PROCEDURE),%ProcToAdd,UNIQUE
    #ENDBOXED
    #BOXED('Equate starting number:')
        #PROMPT('Starting number:',@n3),%Start,UNIQUE
    #ENDBOXED
#Endbutton
#DISPLAY ('  ')
#DISPLAY ('  ')
#!
#ENDTAB
#ENDSHEET
#AT(%GlobalData)
#DECLARE(%Count,LONG)
#DECLARE(%Event1)
#DECLARE(%Event2)
#FOR(%Buttons)
   #SET(%Event1,'Event:DISABLE' & %ProcToAdd & '     EQUATE(' & %Start & 'h)')
   #SET(%Count,%Start + 1)
   #SET(%Event2,'Event:ENABLE' & %ProcToAdd & '     EQUATE(' & %Count & 'h)')
%Event1
%Event2
#ENDFOR
#ENDAT
#!
#GLOBALDATA
GLO:ThreadNo     LONG,EXTERNAL,DLL
GLO:ThreadCount  LONG,EXTERNAL,DLL
#ENDGLOBALDATA
#!
#!==============================================================================================
#!---------------------------------------------------------------
#EXTENSION(TvS_SE_Main,'TvS Single Event Main Menu'),PROCEDURE,HLP('TvS_SE')
#!---------------------------------------------------------------
#!
#!
#SHEET
#TAB('TvS Template - Limit Procedure to Single Event')
#IMAGE('io2.ico'),AT(10,20)
#DISPLAY ('Innovative Options cc'),AT(40,20)
#DISPLAY ('Cape Town, South Africa'),AT(40,30)
#DISPLAY ('Tel: +27 21 5526013   Fax: +27 21 5525582')
#DISPLAY ('Email: innopt@iafrica.com')
#DISPLAY (' ')
#DISPLAY ('This template is part of a set used to disable and')
#DISPLAY ('enable Menu options and Controls to ensure that only')
#DISPLAY ('a single instance of a procedure can be opened at a time')
#DISPLAY (' ')
#DISPLAY ('The set consists of - TvS_SE_Glob  for Global Extension')
#DISPLAY ('                               - TvS_SE-Main  add to the Main App')
#DISPLAY ('                               - TvS_SE_Proc  add to the Procedure')
#DISPLAY (' ')
#DISPLAY (' ')
#BUTTON('Procedure and Controls'),MULTI(%Buttons,%ProcName & ' ' & %ButtonName & ' ' & %MenuName)
   #BOXED('Procedure Definition'),AT(,4)
      #PROMPT('Procedure Name:',PROCEDURE),%ProcName,REQ
   #ENDBOXED
   #BOXED('Toolbar Button - Use Variable')
      #PROMPT('Toolbar button variable:',CONTROL),%ButtonName
   #ENDBOXED
   #BOXED('Menu Item - Use Variable')
      #PROMPT('Menu item variable:',CONTROL),%MenuName
   #ENDBOXED
#ENDBUTTON                                                                     
#DISPLAY ('  ')
#!
#ENDTAB
#ENDSHEET
#AT(%WindowManagerMethodCodeSection,'Init','(),BYTE'),PRIORITY(4900)
   GLO:ThreadNo = Thread()
#ENDAT
#AT(%WindowManagerMethodCodeSection,'TakeWindowEvent','(),BYTE'),PRIORITY(2500)
#DECLARE(%Event1)
#DECLARE(%Event2)
#DECLARE(%Event3)
#FOR(%Buttons)
   #SET(%Event1,'OF EVENT:Disable' & %ProcName)
   %Event1
#IF(%ButtonName <> ' ')
   #SET(%Event2,'   DISABLE(' & %ButtonName & ')')
   %Event2
#ENDIF
#IF(%MenuName <> ' ')
   #SET(%Event3,'   DISABLE(' & %MenuName & ')')
   %Event3
#ENDIF
   #SET(%Event1,'OF EVENT:Enable' & %ProcName)
   %Event1
#IF(%ButtonName <> ' ')
   #SET(%Event2,'   Enable(' & %ButtonName & ')')
   %Event2
#ENDIF
#IF(%MenuName <> ' ')
   #SET(%Event3,'   Enable(' & %MenuName & ')')
   %Event3
#ENDIF
#ENDFOR
#ENDAT
#!
#!
#!==============================================================================================
#!---------------------------------------------------------------
#EXTENSION(TvS_SE_Proc,'TvS Single Event Procedure'),PROCEDURE,HLP('TvS_SE')
#!---------------------------------------------------------------
#!
#!
#SHEET
#TAB('TvS Template - Limit Procedure to Single Event                                   ')
#IMAGE('io2.ico'),AT(10,20)
#DISPLAY ('Innovative Options cc'),AT(40,20)
#DISPLAY ('Cape Town, South Africa'),AT(40,30)
#DISPLAY ('Tel: +27 21 5526013   Fax: +27 21 5525582')
#DISPLAY ('Email: innopt@iafrica.com')
#DISPLAY (' ')
#DISPLAY ('This template is part of a set used to disable and')
#DISPLAY ('enable Menu options and Controls to ensure that only')
#DISPLAY ('a single instance of a procedure can be opened at a time')
#DISPLAY (' ')
#DISPLAY ('The set consists of - TvS_SE_Glob  for Global Extension')
#DISPLAY ('                               - TvS_SE-Main  add to the Main App')
#DISPLAY ('                               - TvS_SE_Proc  add to the Procedure   ')
#DISPLAY (' ')
#DISPLAY (' ')
#DISPLAY ('INSTRUCTIONS ')
#DISPLAY ('1. On the TvS Run Single Event - Global Extension ')
#DISPLAY ('    Add the names of the PROCEDURES to disable.')
#DISPLAY (' ')
#DISPLAY ('2. On the TvS Run Single Event - Main App Extension')
#DISPLAY ('    Add the names of the PROCEDURES to disable.')
#DISPLAY ('    Add the variable names of toolbar buttons.')
#DISPLAY ('    Add the variable names of menu items.')
#DISPLAY (' ')
#DISPLAY ('3. Add the TvS Run Single Event - Procedure ')
#DISPLAY ('    to the PROCEDURE to be disabled.')
#DISPLAY (' ')
#!
#ENDTAB
#ENDSHEET
#AT(%WindowManagerMethodCodeSection,'Init','(),BYTE'),PRIORITY(4900)                  
#DECLARE(%Event1)
   #SET(%Event1,'POST(EVENT:Disable' & %Procedure & ',,GLO:ThreadNo)')
   %Event1
#ENDAT
#AT(%WindowManagerMethodCodeSection,'Kill','(),BYTE'),PRIORITY(4600)
#DECLARE(%Event2)
   #SET(%Event2,'POST(EVENT:Enable' & %Procedure & ',,GLO:ThreadNo)')
   %Event2
#ENDAT
#!==============================================================================================
#!==============================================================================================